{************************************************************}
{                                                            }
{             ScriptReporter 2.1 example unit                }
{                                                            }
{  Function                     Left%Right                   }
{  --------                                                  }
{  Call from script example  Result := 10%3;                 }
{  ------------------------                                  }
{                                                            }
{  Author: Vlad Ilushchenko                                  }
{                                                            }
{************************************************************}

unit ExBinary;

interface

uses Reporter, RepExpr, RepKrnl;

type
  TBinaryExample = class(TRepBinaryExpression)
  protected
    function GetAsVariant: Variant; override;
  end;

implementation

function TBinaryExample.GetAsVariant: Variant;
begin
  Result := Left.Addr.Value mod Right.Addr.Value;
end;

initialization

  {Registering a new plug-in}

  AddPlugIn('%', [akRight, akLeft], TBinaryExample, True );
//           ^    ^                 ^               ^
//           |    |                 |               treated as separate token
//           |    |                 class reference
//           |    argument decription
//           plug-in name


end.

