{**
*
*         Script Reporter Component library
*         Error handling example
*          Vlad Ilushchenko 1998-99
*
*
**}
unit RepErrorsForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, Grids, StdCtrls,
  ExtCtrls, Dialogs;

type
  TfmRepErrors = class(TForm)
    Panel2: TPanel;
    Button1: TButton;
    sgErrors: TStringGrid;
  private
    { Private declarations }
  public
    { Public declarations }
    procedure ShowErrors(S: TStrings);
  end;

var
  fmRepErrors: TfmRepErrors;

implementation

uses RepParamForm, ObjList;

{$R *.DFM}

procedure TfmRepErrors.ShowErrors(S: TStrings);
var
  i: Integer;
  Str: String;
  sz: TSize;
  DC: HDC;
  MaxSize: Integer;
  HOldFont: THandle;
begin
  AdjustSGSizes(sgErrors);
  sgErrors.RowCount := S.Count;
  MaxSize := 0;
  DC := GetDC(Handle);
  HOldFont := SelectObject(DC, sgErrors.Font.Handle);
  try
    with S do
      for i := 0 to Count-1 do
      begin
        Str := Strings[i];
        GetTextExtentPoint32(DC, @Str, Length(Str), sz);
        sgErrors.Cells[0, i] := Str;
        MaxSize := Max(MaxSize, sz.cx);
      end;
  finally
    SelectObject(DC, HOldFont);
    ReleaseDC(Handle, DC);
  end;
  sgErrors.DefaultColWidth := MaxSize;
  ShowModal;
end;

end.
