{**
*
*         Script Reporter Component library
*          Vlad Ilushchenko 1998-99
*
*
**}
unit RepViewForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  FileView, Buttons, ExtCtrls;

type
  TfmRepView = class(TForm)
    Panel1: TPanel;
    btnClose: TSpeedButton;
    btnStop: TSpeedButton;
    FileView: TFileView;
    procedure btnStopClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fmRepView: TfmRepView;

implementation

{$R *.DFM}

uses DebuggerForm;

procedure TfmRepView.btnStopClick(Sender: TObject);
begin
  with fmDebugger.RepDebugger.Reporter do
    if not Terminated then Terminate;
end;

procedure TfmRepView.btnCloseClick(Sender: TObject);
begin
  FileView.CloseFile;
  btnStop.Click;
  ModalResult := mrCancel;
end;

end.
